<?php

declare(strict_types=1);

namespace App\Repository;

final class TblHistorialEvaluacionesRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblHistorialEvaluacionesId): object
    {
        $query = 'SELECT * FROM `TblHistorialEvaluaciones` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblHistorialEvaluacionesId);
        $statement->execute();
        $TblHistorialEvaluaciones = $statement->fetchObject();
        if (! $TblHistorialEvaluaciones) {
            throw new \Exception('TblHistorialEvaluaciones not found.', 404);
        }

        return $TblHistorialEvaluaciones;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblHistorialEvaluaciones` ORDER BY `id` LIMIT 0, 1235';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblHistorialEvaluaciones): object
    {
        $query = 'INSERT INTO `TblHistorialEvaluaciones` (`IdUsuario`, `FechaInicio`, `FechaFin`, `IdTema`, `NumeroIntento`, `Activo`, `Duracion`, `field1`, `field2`, `field3`, `field4`, `field5`) 
        VALUES (:IdUsuario, :FechaInicio, :FechaFin, :IdTema, :NumeroIntento, :Activo, :Duracion, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblHistorialEvaluaciones->id);
//         $statement->bindParam('fecha', $TblHistorialEvaluaciones->fecha);
        $statement->bindParam('IdUsuario', $TblHistorialEvaluaciones->IdUsuario);
        $statement->bindParam('FechaInicio', $TblHistorialEvaluaciones->FechaInicio);
        $statement->bindParam('FechaFin', $TblHistorialEvaluaciones->FechaFin);
        $statement->bindParam('IdTema', $TblHistorialEvaluaciones->IdTema);
        $statement->bindParam('NumeroIntento', $TblHistorialEvaluaciones->NumeroIntento);
        $statement->bindParam('Activo', $TblHistorialEvaluaciones->Activo);
        $statement->bindParam('Duracion', $TblHistorialEvaluaciones->Duracion);
        $statement->bindParam('field1', $TblHistorialEvaluaciones->field1);
        $statement->bindParam('field2', $TblHistorialEvaluaciones->field2);
        $statement->bindParam('field3', $TblHistorialEvaluaciones->field3);
        $statement->bindParam('field4', $TblHistorialEvaluaciones->field4);
        $statement->bindParam('field5', $TblHistorialEvaluaciones->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblHistorialEvaluaciones, object $data): object
    {
        if (isset($data->fecha)) {
            $TblHistorialEvaluaciones->fecha = $data->fecha;
        }
        if (isset($data->IdUsuario)) {
            $TblHistorialEvaluaciones->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->FechaInicio)) {
            $TblHistorialEvaluaciones->FechaInicio = $data->FechaInicio;
        }
        if (isset($data->FechaFin)) {
            $TblHistorialEvaluaciones->FechaFin = $data->FechaFin;
        }
        if (isset($data->IdTema)) {
            $TblHistorialEvaluaciones->IdTema = $data->IdTema;
        }
        if (isset($data->NumeroIntento)) {
            $TblHistorialEvaluaciones->NumeroIntento = $data->NumeroIntento;
        }
        if (isset($data->Activo)) {
            $TblHistorialEvaluaciones->Activo = $data->Activo;
        }
        if (isset($data->Duracion)) {
            $TblHistorialEvaluaciones->Duracion = $data->Duracion;
        }
        if (isset($data->field1)) {
            $TblHistorialEvaluaciones->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblHistorialEvaluaciones->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblHistorialEvaluaciones->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblHistorialEvaluaciones->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblHistorialEvaluaciones->field5 = $data->field5;
        }

        $query = 'UPDATE `TblHistorialEvaluaciones` SET `fecha` = :fecha, `IdUsuario` = :IdUsuario, `FechaInicio` = :FechaInicio, `FechaFin` = :FechaFin, `IdTema` = :IdTema, `NumeroIntento` = :NumeroIntento, `Activo` = :Activo, `Duracion` = :Duracion, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblHistorialEvaluaciones->id);
        $statement->bindParam('fecha', $TblHistorialEvaluaciones->fecha);
        $statement->bindParam('IdUsuario', $TblHistorialEvaluaciones->IdUsuario);
        $statement->bindParam('FechaInicio', $TblHistorialEvaluaciones->FechaInicio);
        $statement->bindParam('FechaFin', $TblHistorialEvaluaciones->FechaFin);
        $statement->bindParam('IdTema', $TblHistorialEvaluaciones->IdTema);
        $statement->bindParam('NumeroIntento', $TblHistorialEvaluaciones->NumeroIntento);
        $statement->bindParam('Activo', $TblHistorialEvaluaciones->Activo);
        $statement->bindParam('Duracion', $TblHistorialEvaluaciones->Duracion);
        $statement->bindParam('field1', $TblHistorialEvaluaciones->field1);
        $statement->bindParam('field2', $TblHistorialEvaluaciones->field2);
        $statement->bindParam('field3', $TblHistorialEvaluaciones->field3);
        $statement->bindParam('field4', $TblHistorialEvaluaciones->field4);
        $statement->bindParam('field5', $TblHistorialEvaluaciones->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblHistorialEvaluaciones->id);
    }

    public function delete(int $TblHistorialEvaluacionesId): void
    {
        $query = 'DELETE FROM `TblHistorialEvaluaciones` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblHistorialEvaluacionesId);
        $statement->execute();
    }
}
